# simu.pl was written by Drake Diedrich, and automatically converted to work
# with pei using $Id: simu.pl,v 2.9.3.1 1997/06/08 20:09:50 root Exp root $

$main'functionmap{'simu'}='&tools_simu'; #'
# $Id: simu.pl,v 2.9.3.1 1997/06/08 20:09:50 root Exp root $
#
# Update simulator for hpc/pei
#


# order as per global/item.c.

sub tools_simu {
  local($area);
  $area = $main'commandarg; #'
  $area = '*' unless $area;
  &build_sect_target($area);
  &print_n_parse("dump *") unless $area eq '*';
  &print_n_parse("prod *");
  &print_n_parse("neweff *");
  &print_n_parse("sdump *");
  &print_n_parse("pdump *");
  &print_n_parse("ldump *");

  local (%dump) = %dump;
  local (%land) = %land;
  local (%ship) = %ship;
  local (%plane) = %plane;

  local (%imported,%exported,%start,%produce,%consume,%delta,%net);


  local (@sectorder,@tmp);
  foreach $sect (keys %dump) {
    if ($dump{$sect}{'own'}==$coun) {
      push(@tmp,$sect);
    }
  }
  @sectorder = sort sortsect @tmp;

  foreach $comm (keys %weight) {
    foreach $sect (@sectorder) {
      if ($dump{$sect}{$comm}>0) {
        $start{$comm} += $dump{$sect}{$comm};
      }
    }
  }
  $start{"tech"} = $nation{$coun}{"tech"} if ($nation{$coun}{"tech"}>0);
  $start{"medic"} = $nation{$coun}{"res"} if ($nation{$coun}{"res"}>0);
  $start{"edu"} = $nation{$coun}{"edu"} if ($nation{$coun}{"edu"}>0);
  $start{"happy"} = $nation{$coun}{"happy"} if ($nation{$coun}{"happy"}>0);

  &landupdate;
  &shipupdate;
  &planeupdate;
  &sectupdate;

  &distexport;
  &distimport;

  foreach $comm (keys %produce) {
    if ($produce{$comm}>0) {
      $start{$comm}=0 unless defined($start{$comm});
    }
  }
  foreach $comm (keys %consume) {
    if ($consume{$comm}) {
      $start{$comm}=0 unless defined($start{$comm});
    }
  }

	
  $consume{"tech"} = $start{"tech"} * $world{'decay'} * $world{'etu'};
  $consume{"medic"} = $start{"medic"} * $world{'decay'} * $world{'etu'};

  foreach $comm (keys %start) {
    $delta{$comm} = $produce{$comm} - $consume{$comm};
    $net{$comm} = $start{$comm} + $produce{$comm} - $consume{$comm};
  }

  if ($produce{"tech"} > $world{'easytech'}) {
    $delta{"tech"} = $world{'easytech'} + 
      log($produce{"tech"}-$world{'easytech'}+1)/log($world{'logtech'});
    $net{"tech"} = $start{"tech"} + $delta{"tech"} - $consume{"tech"};;
  }

  if ($produce{"medic"} > 0.75) {
    $delta{"medic"} = 0.75 + 
      log($produce{"medic"}-0.75+1)/log(2.0);
    $net{"medic"} = $start{"medic"} + $delta{"medic"} - $consume{"medic"};;
  }

  if ($produce{"edu"}) {
    $delta{"edu"} = $produce{"edu"} * 4000 * int($world{'etu'}/12) / $start{"civ"};
    if ($delta{"edu"}>5) {
      $delta{"edu"} = ($delta{"edu"}-5)/(log(1+$delta{"edu"})/log(4)) + 5;
    }
    $net{"edu"} = ($start{"edu"}*(192-$world{'etu'}) + $delta{"edu"} * $world{'etu'})/192;
  }

  if ($produce{"happy"}) {
    $delta{"happy"} = $produce{"happy"} * 5000 * int($world{'etu'}/12) / $start{"civ"};
    if ($delta{"happy"}>5) {
      $delta{"happy"} = ($delta{"happy"}-5)/(log(1+$delta{"happy"})/log(6)) + 5;
    }
    $net{"happy"} = ($start{"happy"}*(192-$world{'etu'}) + $delta{"happy"} * $world{'etu'})/192;
  }



  print "  sect des eff mob make  imports        exports        commodities\n";
  foreach $sect (@sectorder) {
  
next if !$target{$sect};
    printf("%3d,%-3d %s %3d%% %3d",
           $dump{$sect}{"x"},$dump{$sect}{"y"},
           $dump{$sect}{"des"},$dump{$sect}{"eff"},$dump{$sect}{"mob"});
  
    if (defined($will{$sect})) {
      printf(" %4s",$will{$sect} . substr($make{$sect},0,1));
      printf(" ") if (length($will{$sect} . "a") < 5);
    } elsif ($dump{$sect}{"avail"}>0) {
      printf(" %3da ",$dump{$sect}{"avail"});
    } else {
      print "      ";
    }
  
    $impstr="";
    foreach $comm (keys %weight) {
      if ($imported{$sect,$comm}>0) {
        $impstr .= sprintf(" %d%s",$imported{$sect,$comm},substr($comm,0,1));
      }
    }
    printf("%-14s ",$impstr);
     
    $expstr="";
    foreach $comm (keys %weight) {
      if ($exported{$sect,$comm}>0) {
          $expstr .= sprintf(" %d%s",$exported{$sect,$comm},substr($comm,0,1));
      }
    }
    printf("%-14s ",$expstr);
      
    {
      local ($thresh);
      foreach $comm (keys %weight) {
        if ($dump{$sect}{$comm}>0) {
          printf(" %d%s",$dump{$sect}{$comm},substr($comm,0,1));
          $thresh = $dump{$sect}{substr($comm,0,1) . "_dist"};
          if ($thresh>0) {
            print "+" if $dump{$sect}{$comm} > $thresh;
            print "-" if $dump{$sect}{$comm} < $thresh;
          }
        }
      }
    }
    print "\n";
  }

  print "\nship   sect  eff  mob type\n";
  foreach $n (sort keys %ship) {
    my ($type) = $ship{$n}{'type'};	
    next unless $type;
    printf("%4d %3d,%-3d %3d%% %3d %s\n",
	$n,$ship{$n}{'x'},$ship{$n}{'y'},$ship{$n}{'eff'},
	$ship{$n}{'mob'},$type);
  }

  print "\nland   sect  eff  mob type\n";
  foreach $n (sort keys %land) {
    my ($type) = $land{$n}{'type'};	
    next unless $type;
    printf("%4d %3d,%-3d %3d%% %3d %s\n",
	$n,$land{$n}{'x'},$land{$n}{'y'},$land{$n}{'eff'},
	$land{$n}{'mob'},$type);
  }

  print "\nplane  sect  eff  mob type\n";
  foreach $n (sort keys %plane) {
    my ($type) = $plane{$n}{'type'};	
    next unless $type;
    printf("%4d %3d,%-3d %3d%% %3d %s\n",
	$n,$plane{$n}{'x'},$plane{$n}{'y'},$plane{$n}{'eff'},
	$plane{$n}{'mob'},$type);
  }

  $delta{'food'} = int($delta{'food'}+0.5);
  $consume{'food'} = int($consume{'food'}+0.5);
  $net{'food'} = int($net{'food'}+0.5);
  $delta{'tech'} = int(100*$delta{'tech'})/100;
  $produce{'tech'} = int(100*$produce{'tech'})/100;
  $net{'tech'} = int(100*$net{'tech'})/100;
  $consume{'edu'} = int(100*$consume{'edu'})/100;
  $delta{'edu'} = int(100*$delta{'edu'})/100;
  $produce{'edu'} = int(100*$produce{'edu'})/100;
  $consume{'edu'} = int(100*$consume{'edu'})/100;
  $net{'edu'} = int(100*$net{'edu'})/100;
  $consume{'medic'} = int(100*$consume{'medic'})/100;
  $delta{'medic'} = int(100*$delta{'medic'})/100;
  $produce{'medic'} = int(100*$produce{'medic'})/100;
  $consume{'medic'} = int(100*$consume{'medic'})/100;
  $net{'medic'} = int(100*$net{'medic'})/100;
  $consume{'happy'} = int(100*$consume{'happy'})/100;
  $delta{'happy'} = int(100*$delta{'happy'})/100;
  $produce{'happy'} = int(100*$produce{'happy'})/100;
  $consume{'happy'} = int(100*$consume{'happy'})/100;
  $net{'happy'} = int(100*$net{'happy'})/100;


  print "\n  comm    start produce  consume  delta     net\n";
  print "  ----    ----- -------  -------  -----     ---\n";
  foreach $comm (sort keys %net) {
	printf("  %-5s %7g %7g %7g %7g %7g\n",$comm,$start{$comm},
		$delta{$comm}+$consume{$comm},$consume{$comm},
		$delta{$comm},$net{$comm});
  }
}


sub sortsect {
  local (@a, @b);
  @a = split(',',$a);
  @b = split(',',$b);
  ($a[1] <=> $b[1]) || ($a[0] <=> $b[0]);
}

sub sectupdate {

  foreach $sect (@sectorder) {
    if (!defined($world{'option'}{"NOFOOD"})) {
      $eat = ($dump{$sect}{"civ"}+$dump{$sect}{"mil"}+$dump{$sect}{"uw"}) * $world{'etu'} * $world{'eatrate'};
      $eat += 2*($dump{$sect}{"civ"}*$world{'obrate'} + $dump{$sect}{"uw"}*$world{'uwbrate'}) * $world{'etu'} * $world{'babyeat'};
      $dump{$sect}{"food"} -= int($eat);
      $consume{"food"} += $eat;
    }
    if ($dump{$sect}{"food"} < -1) {
      printf("** Warning: need %d more food in %s **\n",-$dump{$sect}{"food"},$sect) if $verbose;
      $dump{$sect}{"work"}=0;
      if (defined($world{'option'}{"NEW_STARVE"})) {
        local ($starve);
        $starve = -$dump{$sect}{"food"} / $world{'etu'} / $world{'eatrate'};
        if ($starve * 2 >
            $dump{$sect}{"uw"} + $dump{$sect}{"civ"} + $dump{$sect}{"mil"}) {
          $starve = int(($dump{$sect}{"uw"} + $dump{$sect}{"civ"} +
                         $dump{$sect}{"mil"})/2);
        }
        if ($starve <= $dump{$sect}{"uw"}) {
          $dump{$sect}{"uw"} -= $starve;
          $consume{"uw"} += $starve;
        } else {
          $starve -= $dump{$sect}{"uw"};
          $consume{"uw"} += $dump{$sect}{"uw"};
          $dump{$sect}{"uw"}=0;
          if ($starve <= $dump{$sect}{"civ"}) {
            $dump{$sect}{"civ"} -= $starve;
            $consume{"civ"} += $starve;
          } else {
            $starve -= $dump{$sect}{"civ"};
            $consume{"civ"} += $dump{$sect}{"civ"};
            $dump{$sect}{"civ"} = 0;
            $consume{"mil"} += $starve;
            $dump{$sect}{"mil"} -= $starve;
          }
        }
      } else {
        $consume{"civ"} += $dump{$sect}{"civ"}/2;
        $consume{"mil"} += $dump{$sect}{"mil"}/2;
        $consume{"uw"} += $dump{$sect}{"uw"}/2;
        $dump{$sect}{"civ"} /= 2;
        $dump{$sect}{"mil"} /= 2;
        $dump{$sect}{"uw"} /= 2;
      }
    } else {
      $produce{"civ"} -= $dump{$sect}{"civ"};
      $produce{"uw"} -= $dump{$sect}{"uw"};
      $dump{$sect}{"civ"} += int($dump{$sect}{"civ"} * $world{'etu'} * $world{'obrate'});
      $dump{$sect}{"uw"} += int($dump{$sect}{"uw"} * $world{'etu'} * $world{'uwbrate'});
      $dump{$sect}{"civ"} = $nation{$coun}{'maxpop'} if ($dump{$sect}{"civ"} > $nation{$coun}{'maxpop'});
      $dump{$sect}{"uw"} = $nation{$coun}{'maxpop'} if ($dump{$sect}{"uw"} > $nation{$coun}{'maxpop'});
      $produce{"civ"} += $dump{$sect}{"civ"};
      $produce{"uw"} += $dump{$sect}{"uw"};
    }
  }


  foreach $sect (@sectorder) {
    $dump{$sect}{'avail'} = ($dump{$sect}{'civ'} * $dump{$sect}{'work'}/100 + $dump{$sect}{'uw'} + $dump{$sect}{'mil'} * 0.4) * $world{'etu'} / 100;
  }

  foreach $sect (keys %neweff) {
    if ($dump{$sect}{'des'} ne $newdes{$sect}) {
      $dump{$sect}{'avail'} -= $neweff{$sect}+$dump{$sect}{'eff'}/4;
    } else {
      $dump{$sect}{'avail'} -= $neweff{$sect}-$dump{$sect}{'eff'};
    }
    $dump{$sect}{"des"} = $newdes{$sect};
    $dump{$sect}{"eff"} = $neweff{$sect};
  }
  foreach $sect (keys %will) {
    if ($will{$sect}+$dump{$sect}{$make{$sect}} > 999) {
      $produce{$make{$sect}} += 999-$dump{$sect}{$make{$sect}};
      $dump{$sect}{$make{$sect}} = 999;
    } else {
      $produce{$make{$sect}} += $will{$sect};
      $dump{$sect}{$make{$sect}} += $will{$sect};
    }
  }

  foreach $sect (keys %use1) {
    $consume{$comm1{$sect}} += $use1{$sect};
    $dump{$sect}{$comm1{$sect}} -= $use1{$sect};
  }
  foreach $sect (keys %use2) {
    $consume{$comm2{$sect}} += $use2{$sect};
    $dump{$sect}{$comm2{$sect}} -= $use2{$sect};
  }
  foreach $sect (keys %use3) {
    $consume{$comm3{$sect}} += $use3{$sect};
    $dump{$sect}{$comm3{$sect}} -= $use3{$sect};
  }


}


sub landupdate {
  local ($sect,$bcost,$lcm,$hcm,$mil,$gun,$shell,$avail);
  foreach $n (sort { $a <=> $b } keys %land) {
    my ($type) = $land{$n}{'type'};
    next unless $type;

    $sect = $land{$n}{'x'} . "," . $land{$n}{'y'};
    if ($dump{$sect}{'des'} eq '!') {
      $bcost = 100 - $land{$n}{"eff"};
      if ($bcost > $land{'max_eff'}) {
        $bcost = $land{'max_eff'};
      }
	  
      my ($buildlcm) = $ship{$type}{'lcm'};
      my ($buildhcm) = $ship{$type}{'hcm'};
      my ($buildgun) = $ship{$type}{'guns'};

      $lcm = $bcost * $buildlcm / 100;
      if ($lcm > $dump{$sect}{"lcm"}) {
        $bcost = 100 * $dump{$sect}{'lcm'} / $buildlcm;
      }

      $hcm = $bcost * $buildhcm / 100;
      if ($hcm > $dump{$sect}{"hcm"}) {
        $bcost = 100 * $dump{$sect}{'hcm'} / $buildhcm;
      }

      $gun = $bcost * $buildgun / 100;
      if ($gun > $dump{$sect}{"gun"}) {
        $bcost = 100 * $dump{$sect}{'gun'} / $buildgun;
      }


      $avail = $bcost * (20 + $buildlcm + 2 * $buildhcm) / 100;
      if ($avail > $dump{$sect}{"avail"}) {
        $bcost = 100 * $dump{$sect}{'avail'} /
          (20 + $buildlcm + 2 * $buildhcm);
      }
      
      $dump{$sect}{"lcm"} -= $bcost * $buildlcm / 100;
      $dump{$sect}{"hcm"} -= $bcost * $buildhcm / 100;
      $dump{$sect}{"gun"} -= $bcost * $buildgun / 100;

      $dump{$sect}{"avail"} -= $bcost * (20 + $buildlcm +
                                        2 * $buildhcm) / 100;

      $consume{"lcm"} += $bcost * $buildlcm / 100;
      $consume{"hcm"} += $bcost * $buildhcm / 100;
      $consume{"gun"} += $bcost * $buildgun / 100;

      $land{$n}{"eff"} += $bcost;

    }
  }
}

sub shipupdate {
  local ($sect,$bcost,$lcm,$hcm,$mil,$gun,$shell,$avail);
  foreach $n (sort keys %ship) {
    my ($type) = $ship{$n}{'type'};
    next unless $type;
    $sect = $ship{$n}{'x'} . "," . $ship{$n}{'y'};
    if ($dump{$sect}{ 'des'} eq 'h') {
      $bcost = 100 - $ship{$n}{"eff"};
      if ($bcost > $ship{'max_eff'}) {
        $bcost = $ship{'max_eff'};
      }

      my ($buildlcm) = $ship{$type}{'lcm'};
      my ($buildhcm) = $ship{$type}{'hcm'};

      $lcm = $bcost * $buildlcm / 100;
      if ($lcm > $dump{$sect}{"lcm"}) {
        $bcost = 100 * $dump{$sect}{'lcm'} / $buildlcm;
      }

      $hcm = $bcost * $buildhcm / 100;
      if ($hcm > $dump{$sect}{"hcm"}) {
        $bcost = 100 * $dump{$sect}{'hcm'} / $buildhcm;
      }


      $avail = $bcost * (20 + $buildlcm + 2 * $buildhcm) / 100;
      if ($avail > $dump{$sect}{"avail"}) {
        $bcost = 100 * $dump{$sect}{'avail'} /
	  (20 + $buildlcm + 2 * $buildhcm);
      }

      $dump{$sect}{"lcm"} -= $bcost * $buildlcm / 100;
      $dump{$sect}{"hcm"} -= $bcost * $buildhcm / 100;
      $dump{$sect}{"avail"} -= $bcost * (20 + $buildlcm + 2 * $buildhcm) / 100;

      $consume{"lcm"} += $bcost * $buildlcm / 100;
      $consume{"hcm"} += $bcost * $buildhcm / 100;
      $ship{$n}{"eff"} += $bcost;
    }
  }
}

# doesn't check for carrier work yet. 
sub planeupdate {
  local ($sect,$bcost,$lcm,$hcm,$mil,$gun,$shell,$avail);
  foreach $n (sort keys %plane) {
    my ($type) = $plane{$n}{'type'};
    next unless $type;
    $sect = $plane{$n}{'x'} . "," . $plane{$n}{'y'};
    if ($dump{$sect}{ 'des'} eq '*') {
      $bcost = 100 - $plane{$n}{"eff"};
      if ($bcost > $plane{'max_eff'}) {
        $bcost = $plane{'max_eff'};
      }
    
      my ($buildlcm) = $plane{$type}{'lcm'};
      my ($buildhcm) = $plane{$type}{'hcm'};
      my ($buildmil) = $plane{$type}{'crew'};

      $lcm = $bcost * $buildlcm / 100;
      if ($lcm > $dump{$sect}{"lcm"}) {
        $bcost = 100 * $dump{$sect}{'lcm'} / $buildlcm;
      }

      $hcm = $bcost * $buildhcm / 100;
      if ($hcm > $dump{$sect}{"hcm"}) {
        $bcost = 100 * $dump{$sect}{'hcm'} / $buildhcm;
      }

      $mil = $bcost * $buildmil / 100;
      if ($mil > $dump{$sect}{"mil"}) {
        $bcost = 100 * $dump{$sect}{'mil'} / $buildmil;
      }


      $avail = $bcost * (20 + $buildlcm + 2 * $buildhcm) / 100;
      if ($avail > $dump{$sect}{"avail"}) {
        $bcost = 100 * $dump{$sect}{'avail'} /
          (20 + $buildlcm + 2 * $buildhcm);
      }

      $dump{$sect}{"lcm"} -= $bcost * $buildlcm / 100;
      $dump{$sect}{"hcm"} -= $bcost * $buildhcm / 100;
      $dump{$sect}{"mil"} -= $bcost * $buildmil / 100;
      $dump{$sect}{"avail"} -= $bcost * (20 + $buildlcm +
                                        2 * $buildhcm) / 100;

      $consume{"lcm"} += $bcost * $buildlcm / 100;
      $consume{"hcm"} += $bcost * $buildhcm / 100;
      $consume{"mil"} += $bcost * $buildmil / 100;

      $plane{$n}{"eff"} += $bcost;

    }
  }
}

sub distexport {
  local ($cost,$com,$lev);
  foreach $source (@sectorder) {
    $dest = $dump{$source}{'dist_x'} . "," . $dump{$source}{'dist_y'};
    $cost = &pathcost($source,$dest);
    if ($cost>1000) {
      print "Unable to find path from $source to $dest\n";
      next;
    }
    next if ($source eq $dest);
    foreach $c (@commo) {
      $comm=$dump{$source}{$commstr{$c}};
      $lev=$dump{$source}{$c . "_dist"};
      if ($lev>0 && $comm>$lev) {
        $move=$comm-$lev;
        $tmp = 9990-$dump{$dest}{$commstr{$c}};
        if ($tmp<$move) { $move = $tmp; }

        $mcost = $cost * $move/4;
        if (( $dump{$dest}{'des'} =~ /[wh]/ && $dump{$dest}{"eff"}>=60) ||
            ($dump{$source}{'des'} =~ /[wh]/ && $dump{$source}{"eff"}>=60)) {
          $mcost /= $packing{$commstr{$c}};
        } elsif ($dump{$source}{'des'} eq 'b' && $dump{$source}{"eff"}>=60 &&
                 $c eq 'b') {
          $mcost /= 4;
        }

        if ($mcost > $dump{$source}{"mob"}) {
          $move *= $dump{$source}{"mob"}/$mcost;
          $mcost = $dump{$source}{"mob"};
        }

        if ($move>0) {
          $dump{$source}{$commstr{$c}} -= $move;
          $dump{$source}{"mob"} -= $mcost;
          $dump{$dest}{$commstr{$c}} += $move;
          $exported{$source,$commstr{$c}} += $move;
          $imported{$dest,$commstr{$c}} += $move;
        }
      }
    }
  }
}

sub distimport {
  local ($cost,$com,$lev);
  foreach $dest (@sectorder) {
    $source = $dump{$dest}{'dist_x'} . "," . $dump{$dest}{'dist_y'};
    $cost = &pathcost($source,$dest);
    if ($cost>1000) {
      print "Unable to find path from $source to $dest\n";
      next;
    }
    next if ($source eq $dest);
    foreach $c (@commo) {
      $comm=$dump{$dest}{$commstr{$c}};
      $lev=$dump{$dest}{$c . "_dist"};
      if ($lev>0 && $lev>$comm) {
        $move=$lev-$comm;
        $tmp = $dump{$source}{$commstr{$c}};
        if ($tmp<$move) { $move = $tmp; }

        $mcost = $cost * $move/4;
        if (($dump{$dest}{'des'} =~ /[wh]/ && $dump{$dest}{"eff"}>=60) ||
            ($dump{$source}{'des'} =~ /[wh]/ && $dump{$source}{"eff"}>=60)) {
          $mcost /= $packing{$commstr{$c}};
        } elsif ($dump{$source}{'des'} eq 'b' && $dump{$source}{"eff"}>=60 &&
                 $c eq 'b') {
          $mcost /= 4;
        }

        if ($mcost > $dump{$source}{"mob"}) {
          $move *= $dump{$source}{"mob"}/$mcost;
          $mcost = $dump{$source}{"mob"};
        }

        if ($move>0) {
          $dump{$source}{$commstr{$c}} -= $move;
          $dump{$source}{"mob"} -= $mcost;
          $dump{$dest}{$commstr{$c}} += $move;
          $exported{$source,$commstr{$c}} += $move;
          $imported{$dest,$commstr{$c}} += $move;
        }
      }
    }
  }
}



sub pathcost {
    local($from, $to) = @_;
    local(%cost,%marked);


    $cost{$from} = 0;
    while (!(defined $cost{$to}) && &buildcost(*cost, *marked)) {
        ;
    }
    if (defined $cost{$to}) {
        return $cost{$to};
    }
    else {
        return 1e9;
    }
    9999;
}

print "Loaded simu.pl\n" if $verbose;
1;
$main'simu_loaded = 1
